#   Copyright (c) 2007 Axel Wachtler
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of the authors nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
#   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
#   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
#   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
#   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#   POSSIBILITY OF SUCH DAMAGE.

# $Id$

#=== modules ==================================================================
import os
from pprint import pprint as pp

Import("doc")

#=== setup build environment ==================================================
ddoc = doc.Clone()

ddoc['dir_build'] = ddoc.Dir(".")
ddoc['dox_install_dir'] = ddoc.Dir("$dox_install_dir/dev")
ddoc['dox_title'] = "Developers Guide"
ddoc['dox_source_browser'] = "NO"
ddoc['dox_generate_tagfile'] = "dev.tag"
ddoc['dox_tagfiles'] = "./install/doc/usr/usr.tag=../usr"
#=== targets ==========================================================
ddoc["dox_input_files"] = "\
                ${dir_top}/Doc/Dev/main.dox\
                ${dir_top}/Doc/Dev/dev.dox\
                ${dir_top}/Doc/gettingstarted.dox\
                ${dir_top}/Doc/Dev/wintools.dox"


ddoc["dox_example_path"] = "${dir_top}/Doc/Dev"
ddoc["dox_aliases"] = "opt{1}=\"<b><tt>\1</tt></b>\""
#=== targets ==========================================================
doxyfile = ddoc.DoxyfileTransformer("Doxyfile","${dir_top}/Doc/Doxyfile.in")

radiosrc = ddoc.Glob("${dir_top}/Src/Lib/Rf230/*.c")
radioh2dot = ddoc.Command("radio.dot", radiosrc,
                          ["python ${dir_top}/Tools/h2dot.py -I ${dir_top}/Src/Lib/Inc $SOURCES > $TARGET"])

ioutilsrc = ddoc.Glob("${dir_top}/Src/Lib/Ioutil/*.c")
ioutilh2dot = ddoc.Command("ioutil.dot", ioutilsrc,
                          ["python ${dir_top}/Tools/h2dot.py -I ${dir_top}/Src/Lib/Inc $SOURCES > $TARGET"])

htmlfile = ddoc.Command("${dox_install_dir}/index.html",
                         [doxyfile, radioh2dot, ioutilh2dot,
                         "${dir_src_doc}/uracoli.css",
                         "${dir_src_doc}/header.html", "${dir_src_doc}/footer.html",
                         ], ["doxygen $SOURCE"])

ddoc.Install("${dox_install_dir}/",ddoc.Glob("ftdi_sio*.patch"))
ddoc.Install("${dox_install_dir}/","ftdi_cdm_2.04.06.patch")
ddoc.Install("${dox_install_dir}/","uracoli-cdc.inf")
ddoc.Depends(htmlfile, ddoc.Split("${dox_input_files} ${dir_top}/LICENSE"))
